; ##############################################################################
; ##############################################################################
; ##############################################################################
;														
; ADC initialisieren mit "Free Run" und Vorteiler		
;														
; 	ADEN: ADC Enable                             		
; 	ADSC: ADC Start Conversion                   		
; 	ADFR: ADC Free Running Select                		
; 	ADIF: ADC Interrzpt Flag                     		
; 	ADIE: ADC Interrupt Enable                   		
; 	ADPS2: Vorteiler                             		
; 	ADPS2: Vorteiler                             		
; 	ADPS2: Vorteiler                             		
;														
;	ADPS2 ADPS1 ADPS0 Division Factor					
;	0 		0 	0 		2								
;	0 		0 	1 		2								
; *	0 		1 	0 		4								
; 	0 		1 	1 		8								
;	1 		0 	0 		16								
; 	1 		0 	1	 	32								
; 	1 		1 	0 		64								
; 	1 		1 	1 		128								
;														
; ADC REFERENZ																		
;																					
; REFS1 REFS0 Voltage Reference Selection											
;  0     0    AREF, Internal Vref turned off										
;  0     1    AVCC with external capacitor at AREF pin								
; *1     1    Internal 2.56V Voltage Reference with external capacitor at AREF pin	
ADC_INITIALISIERUNG_2_56V:
	ldi temp, ((1<<ADEN)|(1<<ADSC)|(1<<ADFR)|(0<<ADPS2)|(1<<ADPS1)|(0<<ADPS0)) 
	out ADCSR, temp

	ldi temp, (1<<REFS1)|(1<<REFS0)|(0<<ADLAR)|(0<<MUX3)|(0<<MUX2)|(0<<MUX1)|(0<<MUX0)
	out ADMUX, temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MESSEN_0_GND:
	in temp, ADMUX
	andi temp, 0b11100000
	ori temp,0b00001111		; 0V (GND)				
	out ADMUX, temp

	rcall MESSEN			; OUT: TEMP1 / TEMP2	


ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MESSEN_0_VBG:
	in temp, ADMUX
	andi temp, 0b11100000
	ori temp,0b00001110		; 1.23V (VBG)			
	out ADMUX, temp

	rcall MESSEN			; OUT: TEMP1 / TEMP2	

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 																				
; Canal 0																		
MESSEN_V:

	in temp, ADMUX
	andi temp, 0b11100000
	subi temp, 0			; KANAL 0	
	out ADMUX, temp

	rcall MESSEN			; OUT: TEMP1 / TEMP2	

	STS(adr_ADC_V_L),temp1	; in SRAM speichern		
	STS(adr_ADC_V_H),temp2	; in SRAM speichern		
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 																				
; Canal 1																		
MESSEN_I:
	in temp, ADMUX
	andi temp, 0b11100000
	subi temp, -1			; KANAL 1	
	out ADMUX, temp

	rcall MESSEN			; OUT: TEMP1 / TEMP2	

	STS(adr_ADC_i_L),temp1	; in SRAM speichern		
	STS(adr_ADC_i_H),temp2	; in SRAM speichern		
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 																				
; Canal 2																		
MESSEN_T:
	in temp, ADMUX
	andi temp, 0b11100000
	subi temp, -2			; KANAL 2	
	out ADMUX, temp

	rcall MESSEN			; OUT: TEMP1 / TEMP2	

	STS(adr_ADC_T_L),temp1	; in SRAM speichern		
	STS(adr_ADC_T_H),temp2	; in SRAM speichern		
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 																				
; Canal 3																		
MESSEN_mV:
	in temp, ADMUX
	andi temp, 0b11100000
	subi temp, -3			; KANAL 3	
	out ADMUX, temp

	rcall MESSEN			; OUT: TEMP1 / TEMP2	

	STS(adr_ADC_mV_L),temp1	; in SRAM speichern		
	STS(adr_ADC_mV_H),temp2	; in SRAM speichern		
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Version: 06.11.2015															
;																				
; ADC-WERT 256 mal einlesen und daraus den Mittelwert bilden					
;																				
; OUT: 	TEMP1 (low)  															
;		TEMP2																	
; 																				
; HILFSREGISTER: R0,R1,temp,temp9 (werden nicht gesichert)						
; 																				
MESSEN:
; neuen ADC-Wert lesen	 Wert verwerfen, da meist vom vorherigem ADC-Kanal	
	sbi ADCSRA, ADIF    	; logisch "1" lscht ADIF flag !
;-------------------------------------------------------------------------------
MESSEN_w:                  
	sbis ADCSRA, ADIF		; warten bis ADIF flag gesetzt	
	rjmp MESSEN_w
;-------------------------------------------------------------------------------
	clr temp				; HILFSREGISTER CLEAR			
	clr temp1					
	clr temp2
	clr temp9				; SCHLEIFE initialisieren		
;-------------------------------------------------------------------------------
; neuen ADC-Wert lesen	(Schleife - 256 mal)								
MESSEN_SCHLEIFE:                
	sbi ADCSRA, ADIF    	; logisch "1" lscht ADIF flag !
MESSEN_SCHLEIFE_w:                
	sbis ADCSR, ADIF 		; warten bis ADIF flag gesetzt	
	rjmp MESSEN_SCHLEIFE_w
; ADC einlesen:																
	in  R0, ADCL 			; immer zuerst LOW Byte lesen
	in  R1, ADCH 			; danach das mittlerweile gesperrte High Byte
; alle 256 ADC-Werte addieren												
	add temp ,R0     		; addieren  						
	adc temp1,R1     		; addieren ber Carry  				
	adc temp2,NULL 	 		; addieren ber Carry  				
	dec temp9		 		; Schleifenzhler MINUS 1			
	brne MESSEN_SCHLEIFE 	; ==> SCHLEIFE						
; MITTELWERT-BERECHNUNG	(128 addieren), ERGEBNIS in temp1+2					
	subi temp , BYTE1(-128)
	sbci temp1, BYTE2(-128)
	sbci temp2, BYTE3(-128)
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################

