; ##############################################################################
; ##############################################################################
; ##############################################################################
;																				
; Ein Byte aus EEPROM holen und Z-Zeiger + 1									
;																				
; INPUT:	ZL Adresse (low)													
;			ZH Adresse (High)													
;																				
; OUTPUT: 	TEMP (DATEN)														
;																				
; rcall EEPROM_READ_PLUS ; INP: ZL+ZH(ADRESSE) OUT: TEMP (DATEN)				
;																				
EEPROM_READ_Z_TEMP:
	sbic EECR,EEWE 		; Wait for completion of previous write
	rjmp EEPROM_READ_Z_TEMP
	out  EEARH, ZH		; ADRESSE setzen						
	out  EEARL, ZL
	sbi  EECR,EERE		; Start eeprom read by writing EERE		
	in 	 temp,EEDR		; Read data from data register			
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
;																				
; Ein Byte im EEPROM ablegen und Z-Zeiger + 1									
;																				
; INPUT:	ZL Adresse (low)													
;			ZH Adresse (High)													
;																				
; 		 	TEMP  DATEN															
;																				
;	rcall EEPROM_WRITE_PLUS	; INP: TEMP1(DATEN) ZL+ZH(ADRESSE) (Z+1)			
;																				
EEPROM_WRITE_Z_TEMP:
	sbic EECR,EEWE		; Wait for completion of previous write
	rjmp EEPROM_WRITE_Z_TEMP
	out  EEARH,ZH		; ADRESSE setzen						
	out  EEARL,ZL
	out  EEDR, temp		; Write data  to data register			
	sbi  EECR, EEMWE	; Write logical one to EEMWE			
	sbi  EECR, EEWE		; Start eeprom write by setting EEWE	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
EEPROM_KONFIGURATION_LADEN:
;-------------------------------------------------------------------------------
	ldi ZL, low (adr_DATEN)
	ldi ZH, high(adr_DATEN)
	rcall EEPROM_READ_Z_TEMP		; READ
	cpi temp,(VERSION)
	breq EEPROM_KONFIGURATION_RUN
	ldi temp,(ASCII_C)
	STS(adr_LED_BYTE_2),temp
	ldi temp,(ASCII_A)
	STS(adr_LED_BYTE_1),temp
	ldi temp,(ASCII_L)
	STS(adr_LED_BYTE_0),temp

	ldi temp,(ASCII_E)
	STS(adr_LED_BYTE_5),temp
	STS(adr_LED_BYTE_4),temp
	STS(adr_LED_BYTE_3),temp
	rcall WAIT_1s
	ret
;-------------------------------------------------------------------------------
EEPROM_KONFIGURATION_RUN:
	ldi ZL, low (adr_DATEN)
	ldi ZH, high(adr_DATEN)
	ldi temp9,20
;-------------------------------------------------------------------------------
EEPROM_KONFIGURATION_LADEN_s:
	rcall EEPROM_READ_Z_TEMP		; READ
	ST Z+, temp
	dec temp9
	brne EEPROM_KONFIGURATION_LADEN_s
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
EEPROM_KONFIGURATION_SPEICHERN:
	ldi temp,(ASCII_S)				; LED-GRUEN
	STS(adr_LED_BYTE_2),temp
	ldi temp,(ASCII_A)
	STS(adr_LED_BYTE_1),temp
	ldi temp,(ASCII_F)
	STS(adr_LED_BYTE_0),temp
;-------------------------------------------------------------------------------
	ldi temp,(VERSION)
	STS(adr_VERSION),temp
;-------------------------------------------------------------------------------
	ldi ZL, low (adr_DATEN)
	ldi ZH, high(adr_DATEN)
	ldi temp9,20
EEPROM_KONFIGURATION_SICHERN_s:
	LD temp,Z
	rcall EEPROM_WRITE_Z_TEMP		; write
	adiw ZL,1
	dec temp9
	brne EEPROM_KONFIGURATION_SICHERN_s
	rcall WAIT_1s
	STS(adr_MENUE),NULL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
