; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE:
	; TASTE MENUE gedrckt ?	
	LDS temp,(adr_TASTE)
	cpi temp,(TASTE_MENUE)
	brne MENUE_RUN
	LDS temp,(adr_MENUE)
	inc temp
	STS(adr_MENUE),temp
;-------------------------------------------------------------------------------
MENUE_RUN:
	ldi ZL,LOW (MENUE_SPRUNGMARKE)
	ldi ZH,HIGH(MENUE_SPRUNGMARKE)
	LDS temp,(adr_MENUE)
	add ZL,temp
	adc ZH,NULL
	ijmp ; Sprung nach Z 
;-------------------------------------------------------------------------------
MENUE_SPRUNGMARKE:
	rjmp MENUE_HAUPT
	rjmp MENUE_TEMPERATUR
	rjmp MENUE_PWM
	rjmp MENUE_CAL_2V
	rjmp MENUE_CAL_28V
	rjmp MENUE_CAL_0A
	rjmp MENUE_CAL_1A
	rjmp MENUE_CAL_2A
	rjmp MENUE_ADC_0
	rjmp MENUE_ADC_1
	rjmp MENUE_ADC_2
	rjmp MENUE_ADC_3
	STS(adr_MENUE),NULL
	rjmp MENUE_RUN
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_HAUPT:
	LDS temp1,(adr_ADC_mV_L)		; Nullen anzeigen	
	LDS temp2,(adr_ADC_mV_H)
	tst temp1
	brne MENUE_HAUPT_RUN
	tst temp2
	brne MENUE_HAUPT_RUN
	ldi temp,(ASCII_0)
	STS(adr_LED_BYTE_0),temp
	STS(adr_LED_BYTE_1),temp
	STS(adr_LED_BYTE_2),temp
	LDS temp,(adr_LED_BYTE_2)			; PUNKT			
	ori temp,0b10000000
	STS(adr_LED_BYTE_2),temp
	rjmp MENUE_HAUPT_STROM
;-------------------------------------------------------------------------------
MENUE_HAUPT_RUN:
	LDS temp1,(adr_ADC_mV_L)			; mV	
	LDS temp2,(adr_ADC_mV_H)
	cpi temp2,HIGH(1023)
	breq MENUE_HAUPT_L
	brsh MENUE_HAUPT_V
	brlo MENUE_HAUPT_mV
MENUE_HAUPT_L:
	cpi temp1,LOW(1023)
	breq MENUE_HAUPT_V
	brsh MENUE_HAUPT_V
	brlo MENUE_HAUPT_mV
;-------------------------------------------------------------------------------
; 0...2,6V																		
MENUE_HAUPT_mV:
	rcall BERECHNUNG_mV_TEMP1_2
	rcall ZAHL_GRUEN_TEMP1_2			; LED-GRN		
	LDS temp,(adr_LED_BYTE_2)			; PUNKT			
	ori temp,0b10000000
	STS(adr_LED_BYTE_2),temp
	rjmp MENUE_HAUPT_STROM
;-------------------------------------------------------------------------------
; 2,6...30V																		
MENUE_HAUPT_V:
	rcall BERECHNUNG_V_TEMP1_2			; Berechnung	
	rcall ZAHL_GRUEN_TEMP1_2			; LED-GRN		
	LDS temp,(adr_LED_BYTE_1)			; PUNKT			
	ori temp,0b10000000
	STS(adr_LED_BYTE_1),temp
	
	LDS temp,(adr_LED_BYTE_2)
	cpi temp,(ASCII_0)
	brne MENUE_HAUPT_STROM
	STS(adr_LED_BYTE_2),NULL
;-------------------------------------------------------------------------------
MENUE_HAUPT_STROM:
	rcall BERECHNUNG_STROM_TEMP1_2		; Berechnung	
	rcall ZAHL_ROT_TEMP1_2				; LED-ROT		
	LDS temp,(adr_LED_BYTE_5)			; PUNKT			
	ori temp,0b10000000
	STS(adr_LED_BYTE_5),temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_TEMPERATUR:
	ldi temp,(ASCII_GRD)
	STS(adr_LED_BYTE_2),temp
	ldi temp,(ASCII_C)
	STS(adr_LED_BYTE_1),temp
	STS(adr_LED_BYTE_0),NULL

	LDS temp1,(adr_TEMPERATUR)
	clr temp2
	rcall ZAHL_ROT_TEMP1_2
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_PWM:
	ldi temp,(ASCII_P)
	STS(adr_LED_BYTE_2),temp
	STS(adr_LED_BYTE_1),NULL
	STS(adr_LED_BYTE_0),NULL

	LDS temp1,(adr_PWM_IST)				; LED-ROT		
	clr temp2
	rcall ZAHL_ROT_TEMP1_2
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Kalibrierung 28Volt															
MENUE_CAL_2V:
	ldi temp,(ASCII_C)	; Text gruen	
	STS(adr_LED_BYTE_2),temp
	ldi temp,(ASCII_A)
	STS(adr_LED_BYTE_1),temp
	ldi temp,(ASCII_L)
	STS(adr_LED_BYTE_0),temp

	ldi temp,(ASCII_SPACE)	; Text rot		
	STS(adr_LED_BYTE_5),temp
	ldi temp,(ASCII_2)
	STS(adr_LED_BYTE_4),temp
	ldi temp,(ASCII_U)
	STS(adr_LED_BYTE_3),temp

	LDS temp,(adr_TASTE)
	cpi temp,(TASTE_ENTER)
	breq MENUE_CAL_2V_RUN
	ret
;-------------------------------------------------------------------------------	ret
MENUE_CAL_2V_RUN:
	ldi temp1,BYTE1(200*1024)
	ldi temp2,BYTE2(200*1024)
	ldi temp3,BYTE3(200*1024)
	ldi temp4,BYTE4(200*1024)

	LDS temp5,(adr_ADC_mV_L)
	LDS temp6,(adr_ADC_mV_H)
	clr temp7
	clr temp8
	rcall DIVISION_32_32

	STS(adr_FAKTOR_mV_L),temp1
	STS(adr_FAKTOR_mV_H),temp2

	rcall ZAHL_ROT_TEMP1_2					; LED-ROT		

	rcall EEPROM_KONFIGURATION_SPEICHERN	; SAVE			
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Kalibrierung 28Volt															
MENUE_CAL_28V:
	ldi temp,(ASCII_C)	; Text gruen	
	STS(adr_LED_BYTE_2),temp
	ldi temp,(ASCII_A)
	STS(adr_LED_BYTE_1),temp
	ldi temp,(ASCII_L)
	STS(adr_LED_BYTE_0),temp

	ldi temp,(ASCII_2)	; Text rot		
	STS(adr_LED_BYTE_5),temp
	ldi temp,(ASCII_8)
	STS(adr_LED_BYTE_4),temp
	ldi temp,(ASCII_U)
	STS(adr_LED_BYTE_3),temp

	LDS temp,(adr_TASTE)
	cpi temp,(TASTE_ENTER)
	breq MENUE_CAL_28V_RUN
	ret
;-------------------------------------------------------------------------------	ret
MENUE_CAL_28V_RUN:
	ldi temp1,BYTE1(280*1024)
	ldi temp2,BYTE2(280*1024)
	ldi temp3,BYTE3(280*1024)
	ldi temp4,BYTE4(280*1024)

	LDS temp5,(adr_ADC_V_L)
	LDS temp6,(adr_ADC_V_H)
	clr temp7
	clr temp8
	rcall DIVISION_32_32

	STS(adr_FAKTOR_V_L),temp1
	STS(adr_FAKTOR_V_H),temp2
	rcall ZAHL_ROT_TEMP1_2					; LED-ROT		
	rcall EEPROM_KONFIGURATION_SPEICHERN	; SAVE			
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Kalibrierung 0 Ampere (Offset)												
MENUE_CAL_0A:
	ldi temp,(ASCII_C)	; Text gruen	
	STS(adr_LED_BYTE_2),temp
	ldi temp,(ASCII_A)
	STS(adr_LED_BYTE_1),temp
	ldi temp,(ASCII_L)
	STS(adr_LED_BYTE_0),temp

	ldi temp,(ASCII_0)	; Text rot		
	STS(adr_LED_BYTE_5),temp
	ldi temp,(ASCII_SPACE)
	STS(adr_LED_BYTE_4),temp
	ldi temp,(ASCII_A)
	STS(adr_LED_BYTE_3),temp

	LDS temp,(adr_TASTE)
	cpi temp,(TASTE_ENTER)
	breq MENUE_CAL_0A_RUN
	ret
;-------------------------------------------------------------------------------	ret
MENUE_CAL_0A_RUN:
	STS(adr_LED_BYTE_2),NULL				; LED-GRUEN		
	STS(adr_LED_BYTE_1),NULL
	STS(adr_LED_BYTE_0),NULL

	LDS temp1,(adr_ADC_i_L)
	LDS temp2,(adr_ADC_i_H)
	STS(adr_OFFSET_I_L),temp1
	STS(adr_OFFSET_I_H),temp2

	LDS temp1,(adr_ADC_i_L)
	LDS temp2,(adr_ADC_i_H)
	rcall ZAHL_ROT_TEMP1_2				; LED-ROT		

	rcall WAIT_1s
	rcall EEPROM_KONFIGURATION_SPEICHERN	; SAVE			
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Kalibrierung 1 Ampere															
MENUE_CAL_1A:
	ldi temp,(ASCII_C)	; Text gruen	
	STS(adr_LED_BYTE_2),temp
	ldi temp,(ASCII_A)
	STS(adr_LED_BYTE_1),temp
	ldi temp,(ASCII_L)
	STS(adr_LED_BYTE_0),temp

	ldi temp,(ASCII_1)	; Text rot		
	STS(adr_LED_BYTE_5),temp
	ldi temp,(ASCII_SPACE)
	STS(adr_LED_BYTE_4),temp
	ldi temp,(ASCII_A)
	STS(adr_LED_BYTE_3),temp

	LDS temp,(adr_TASTE)
	cpi temp,(TASTE_ENTER)
	breq MENUE_CAL_1A_RUN
	ret
;-------------------------------------------------------------------------------	ret
MENUE_CAL_1A_RUN:
	STS(adr_LED_BYTE_2),NULL				; LED-GRUEN		
	STS(adr_LED_BYTE_1),NULL
	STS(adr_LED_BYTE_0),NULL

	ldi temp1,BYTE1(100*1024)
	ldi temp2,BYTE2(100*1024)
	ldi temp3,BYTE3(100*1024)
	ldi temp4,BYTE4(100*1024)

	LDS temp5,(adr_ADC_i_L)			; ADC
	LDS temp6,(adr_ADC_i_H)
	clr temp7
	clr temp8

	LDS R0,(adr_OFFSET_I_L)			; OFFSET	
	LDS R1,(adr_OFFSET_I_H)
	sub temp5,R0					; ADC-Offset
	sbc temp6,R1
	sbc temp7,NULL
	sbc temp8,NULL
	rcall DIVISION_32_32

	STS(adr_FAKTOR_I_L),temp1
	STS(adr_FAKTOR_I_H),temp2
	rcall ZAHL_ROT_TEMP1_2				; LED-ROT		

	rcall WAIT_1s
	rcall EEPROM_KONFIGURATION_SPEICHERN	; SAVE			
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Kalibrierung 2 Ampere															
MENUE_CAL_2A:
	ldi temp,(ASCII_C)	; Text gruen	
	STS(adr_LED_BYTE_2),temp
	ldi temp,(ASCII_A)
	STS(adr_LED_BYTE_1),temp
	ldi temp,(ASCII_L)
	STS(adr_LED_BYTE_0),temp

	ldi temp,(ASCII_2)	; Text rot		
	STS(adr_LED_BYTE_5),temp
	ldi temp,(ASCII_SPACE)
	STS(adr_LED_BYTE_4),temp
	ldi temp,(ASCII_A)
	STS(adr_LED_BYTE_3),temp

	LDS temp,(adr_TASTE)
	cpi temp,(TASTE_ENTER)
	breq MENUE_CAL_2A_RUN
	ret
;-------------------------------------------------------------------------------	ret
MENUE_CAL_2A_RUN:
	STS(adr_LED_BYTE_2),NULL				; LED-GRUEN		
	STS(adr_LED_BYTE_1),NULL
	STS(adr_LED_BYTE_0),NULL

	ldi temp1,BYTE1(200*1024)
	ldi temp2,BYTE2(200*1024)
	ldi temp3,BYTE3(200*1024)
	ldi temp4,BYTE4(200*1024)

	LDS temp5,(adr_ADC_i_L)			; ADC
	LDS temp6,(adr_ADC_i_H)
	clr temp7
	clr temp8

	LDS R0,(adr_OFFSET_I_L)			; OFFSET	
	LDS R1,(adr_OFFSET_I_H)
	sub temp5,R0					; ADC-Offset
	sbc temp6,R1
	sbc temp7,NULL
	sbc temp8,NULL
	rcall DIVISION_32_32

	STS(adr_FAKTOR_I_L),temp1
	STS(adr_FAKTOR_I_H),temp2
	rcall ZAHL_ROT_TEMP1_2				; LED-ROT		

	rcall WAIT_1s
	rcall EEPROM_KONFIGURATION_SPEICHERN	; SAVE			
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_ADC_0:
	ldi temp,(ASCII_A)			; LED GRN	
	STS(adr_LED_BYTE_2),temp
	STS(adr_LED_BYTE_1),NULL
	ldi temp,(ASCII_0)
	STS(adr_LED_BYTE_0),temp

	LDS temp1,(adr_ADC_V_L)	; ADC		
	LDS temp2,(adr_ADC_V_H)
	rcall ZAHL_ROT_TEMP1_2		; LED-ROT	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_ADC_1:
	ldi temp,(ASCII_A)			; LED GRN	
	STS(adr_LED_BYTE_2),temp
	STS(adr_LED_BYTE_1),NULL
	ldi temp,(ASCII_1)
	STS(adr_LED_BYTE_0),temp

	LDS temp1,(adr_ADC_i_L)		; ADC		
	LDS temp2,(adr_ADC_i_H)
	rcall ZAHL_ROT_TEMP1_2		; LED-ROT	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_ADC_2:
	ldi temp,(ASCII_A)			; LED GRN	
	STS(adr_LED_BYTE_2),temp
	STS(adr_LED_BYTE_1),NULL
	ldi temp,(ASCII_2)
	STS(adr_LED_BYTE_0),temp

	LDS temp1,(adr_ADC_T_L)		; ADC		
	LDS temp2,(adr_ADC_T_H)
	rcall ZAHL_ROT_TEMP1_2		; LED-ROT	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE_ADC_3:
	ldi temp,(ASCII_A)			; LED GRN	
	STS(adr_LED_BYTE_2),temp
	STS(adr_LED_BYTE_1),NULL
	ldi temp,(ASCII_3)
	STS(adr_LED_BYTE_0),temp

	LDS temp1,(adr_ADC_mV_L)	; ADC		
	LDS temp2,(adr_ADC_mV_H)
	rcall ZAHL_ROT_TEMP1_2		; LED-ROT	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
