;												
; ATmega8 - 1 MHz								
;												
; Bernhard.Erfurt@gmx.de						
; 11/2020										
;												


; ATmega8 										
.include "m8def.inc"
.include "MACRO.asm"
; KONSTANTEN									
.equ VERSION				= 1
.equ TAKT					=1000000			; 1 MHz	
; ASCII											
.equ ASCII_0				=0b00111111	; 0 
.equ ASCII_1				=0b00000110	; 1 
.equ ASCII_2				=0b01011011	; 2 
.equ ASCII_3				=0b01001111	; 3 
.equ ASCII_4				=0b01100110	; 4 
.equ ASCII_5				=0b01101101	; 5 
.equ ASCII_6				=0b01111101	; 6 
.equ ASCII_7				=0b00000111	; 7 
.equ ASCII_8				=0b01111111	; 8 
.equ ASCII_9				=0b01101111	; 9 

.equ ASCII_SPACE			=0b00000000	; ''
.equ ASCII_PUNKT			=0b10000000	; . 
.equ ASCII_VOLL				=0b11111111	; 8.
.equ ASCII_MINUS			=0b01000000	; - 
.equ ASCII_GRD				=0b01100011	;  

.equ ASCII_A				=0b01110111	; A 
.equ ASCII_B				=0b01111100	; B 
.equ ASCII_C				=0b00111001	; C 
.equ ASCII_D				=0b01011110	; D 
.equ ASCII_E				=0b01111001	; E 
.equ ASCII_F				=0b01110001	; F 
.equ ASCII_H				=0b01110110	; H 
.equ ASCII_I				=0b00000110	; H 
.equ ASCII_L				=0b00111000	; L 
.equ ASCII_N				=0b01010100	; N 
.equ ASCII_O				=0b00111111	; 0 
.equ ASCII_R				=0b01010000	; R 
.equ ASCII_S				=0b01101101	; S 
.equ ASCII_T				=0b01111000	; T 
.equ ASCII_U				=0b00011100	; U 
.equ ASCII_U_				=0b00011100	; u 
.equ ASCII_V				=0b00011100	; V 
.equ ASCII_P				=0b01110011	; P
.equ ASCII_Y				=0b01101110	; Y

; TASTE "M"									
.equ TASTE_MENUE			= 1
.equ TASTE_M_PIN_NR			= 6
.equ TASTE_M_PIN			= PINB
.equ TASTE_M_DDR			= DDRB
.equ TASTE_M_PORT			= PORTB
; TASTE "E"									
.equ TASTE_ENTER			= 2
.equ TASTE_E_PIN_NR			= 7
.equ TASTE_E_PIN			= PINB
.equ TASTE_E_DDR			= DDRB
.equ TASTE_E_PORT			= PORTB
; PWM										
.equ PWM_PIN_NR				= 5
.equ PWM_DDR				= DDRC
.equ PWM_PORT				= PORTC
; BELEGUNG 7-Segment-Anzeige							
;														
.equ DDR_DIG_0				=DDRD
.equ DDR_DIG_1				=DDRB
.equ DDR_DIG_2				=DDRB
.equ DDR_DIG_3				=DDRD
.equ DDR_DIG_4				=DDRD
.equ DDR_DIG_5				=DDRD

.equ PORT_DIG_0				=PORTD		
.equ PORT_DIG_1				=PORTB		
.equ PORT_DIG_2				=PORTB	
.equ PORT_DIG_3				=PORTD
.equ PORT_DIG_4				=PORTD
.equ PORT_DIG_5				=PORTD

.equ PIN_DIG_0				=7
.equ PIN_DIG_1				=1
.equ PIN_DIG_2				=0
.equ PIN_DIG_3				=0
.equ PIN_DIG_4				=5
.equ PIN_DIG_5				=6
; BALKEN												
.equ DDR_BALKEN_A			=DDRB
.equ DDR_BALKEN_B			=DDRB
.equ DDR_BALKEN_C			=DDRD
.equ DDR_BALKEN_D			=DDRD
.equ DDR_BALKEN_E			=DDRD
.equ DDR_BALKEN_F			=DDRB
.equ DDR_BALKEN_G			=DDRB
.equ DDR_BALKEN_P			=DDRD

.equ BALKEN_A				=PORTB		
.equ BALKEN_B				=PORTB			
.equ BALKEN_C				=PORTD		
.equ BALKEN_D				=PORTD		
.equ BALKEN_E				=PORTD		
.equ BALKEN_F				=PORTB		
.equ BALKEN_G				=PORTB		
.equ BALKEN_P				=PORTD

.equ PIN_BALKEN_A			=5
.equ PIN_BALKEN_B			=2
.equ PIN_BALKEN_C			=3
.equ PIN_BALKEN_D			=2
.equ PIN_BALKEN_E			=1
.equ PIN_BALKEN_F			=4
.equ PIN_BALKEN_G			=3
.equ PIN_BALKEN_P			=4

; SRAM-BELEGUNG ATmega8							
.equ adr_DATEN					=SRAM_START+0			; 0x0060 START Adresse 		
.equ adr_VERSION				=SRAM_START+0

.equ adr_FAKTOR_V_L				=SRAM_START+2
.equ adr_FAKTOR_V_H				=SRAM_START+3
.equ adr_FAKTOR_mV_L			=SRAM_START+4
.equ adr_FAKTOR_mV_H			=SRAM_START+5
.equ adr_FAKTOR_I_L				=SRAM_START+6
.equ adr_FAKTOR_I_H				=SRAM_START+7
.equ adr_OFFSET_I_L				=SRAM_START+8
.equ adr_OFFSET_I_H				=SRAM_START+9

.equ adr_MENUE					=SRAM_START+20
.equ adr_TASTE					=SRAM_START+21
.equ adr_TEMPERATUR				=SRAM_START+22
.equ adr_PWM_SOLL				=SRAM_START+23
.equ adr_PWM_IST				=SRAM_START+24
.equ adr_PWM_COUNTER			=SRAM_START+25
.equ adr_VT_L					=SRAM_START+26
.equ adr_VT_H					=SRAM_START+27

.equ adr_ADC_V_L				=SRAM_START+50
.equ adr_ADC_V_H				=SRAM_START+51
.equ adr_ADC_i_L				=SRAM_START+52
.equ adr_ADC_i_H				=SRAM_START+53
.equ adr_ADC_T_L				=SRAM_START+54
.equ adr_ADC_T_H				=SRAM_START+55
.equ adr_ADC_mV_L				=SRAM_START+56
.equ adr_ADC_mV_H				=SRAM_START+57

.equ adr_LED_ZAEHLER			= SRAM_START+90
.equ adr_LED_BYTE_0				= SRAM_START+100		; DIGIT (rechts)
.equ adr_LED_BYTE_1				= SRAM_START+101
.equ adr_LED_BYTE_2				= SRAM_START+102
.equ adr_LED_BYTE_3				= SRAM_START+103
.equ adr_LED_BYTE_4				= SRAM_START+104
.equ adr_LED_BYTE_5				= SRAM_START+105

.equ adr_SRAM_CHECK					=SRAM_START+943	; SRAM CHECK muss immer "S" sein	


; REGISTER										

.def TWI_FEHLER_CODE	= R12
.def NULL 				= R14
.def EINS 				= R15

.def temp 	= R16
.def temp1 	= R17
.def temp2 	= R18
.def temp3 	= R19
.def temp4 	= R20
.def temp5 	= R21
.def temp6 	= R22
.def temp7 	= R23
.def temp8 	= R24
.def temp9 	= R25





.cseg					;Beginn eines Code-Segmentes
.org 0					;Startadresse=0

rjmp RESET      		; Reset Handler                           				
rjmp INTERRUPT_ERROR	;rjmp EXT_INT0   ; IRQ0 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp EXT_INT1   ; IRQ1 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp TIM2_COMP  ; Timer2 Compare Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM2_OVF   ; Timer2 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_CAPT  ; Timer1 Capture Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPA ; Timer1 CompareA Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPB ; Timer1 CompareB Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_OVF   ; Timer1 Overflow Handler           	
rjmp TIM0_OVF   		; Timer0 Overflow Handler           					
rjmp INTERRUPT_ERROR	;rjmp SPI_STC    ; SPI Transfer Complete Handler     	
rjmp INTERRUPT_ERROR	; USART RX Complete Handler         					
rjmp INTERRUPT_ERROR	;rjmp USART_UDRE ; UDR Empty Handler                 	
rjmp INTERRUPT_ERROR	;rjmp USART_TXC  ; USART TX Complete Handler         	
rjmp INTERRUPT_ERROR	;rjmp ADC        ; ADC Conversion Complete Handler   	
rjmp INTERRUPT_ERROR	;rjmp EE_RDY     ; EEPROM Ready Handler              	
rjmp INTERRUPT_ERROR	;rjmp ANA_COMP   ; Analog Comparator Handler         	
rjmp INTERRUPT_ERROR	;rjmp TWSI      ; Two-wire Serial Interface Handler 					
rjmp INTERRUPT_ERROR	;rjmp SPM_RDY    ; Store Program Memory Ready Handler	


; Bei unkorrekten Interrupt aufrufen erfolgt ein RESET ber WDR	
INTERRUPT_ERROR:
	wdr	
INTERRUPT_ERROR_SCHLEIFE:
	rjmp INTERRUPT_ERROR_SCHLEIFE

RESET:                        
; STACK initialisieren								
	ldi temp, LOW(RAMEND)
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp


	rcall WDR_INITIALISIERUNG; WDR_INITIALISIERUNG								
	rcall SRAM_CLEAR
	rcall PORT_CLEAR
	rcall REGISTER_CLEAR
	rcall STARTWERTE
	rcall PORT_INITIALISIERUNG
	rcall ADC_INITIALISIERUNG_2_56V
	rcall TIMER0_INITIALISIERUNG
	rcall TIMER_AKTIVIEREN
	rcall TASTATUR_INITIALISIERUNG
	SEI  ; interrupts freigeben								
;-------------------------------------------------------------------------------
	rcall EEPROM_KONFIGURATION_LADEN
	rcall MESSEN_BERECHNEN
; ##############################################################################
; ##############################################################################
; ##############################################################################
LOOP:
	WDR
	rcall PROGRAMM_CHECK
	rcall MENUE
	rcall TASTEN_WAIT
	rcall WAIT_20ms
	rcall MESSEN_BERECHNEN
rjmp LOOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
MESSEN_BERECHNEN:
	rcall MESSEN_V
	rcall MESSEN_I
	rcall MESSEN_T
	rcall MESSEN_mV
	rcall BERECHNUNG_TEMPERATUR_TEMP1_2
	rcall BERECHNUNG_PWM
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TASTEN_WAIT:
	LDS temp,(adr_TASTE)
	tst temp
	brne TASTEN_WAIT_RUN
	ret
;-------------------------------------------------------------------------------
TASTEN_WAIT_RUN:
	STS(adr_LED_BYTE_2),NULL
	STS(adr_LED_BYTE_1),NULL
	STS(adr_LED_BYTE_0),NULL
	STS(adr_LED_BYTE_5),NULL
	STS(adr_LED_BYTE_4),NULL
	STS(adr_LED_BYTE_3),NULL
	rcall WAIT_100ms
	STS(adr_TASTE),NULL	; TASTE clear	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; PWM fr Motor																	
BERECHNUNG_PWM:
	LDS temp1,(adr_TEMPERATUR)
	cpi temp1,50 ; C			
	ldi temp9,0	 ; PWM (soll)	
	brlo BERECHNUNG_PWM_w

	cpi temp1,51 ;  C			
	ldi temp9,80; 	PWM (soll)	
	breq BERECHNUNG_PWM_w
	brlo BERECHNUNG_PWM_w

	cpi temp1,52 ; C			
	ldi temp9,100; 	PWM (soll)	
	breq BERECHNUNG_PWM_w
	brlo BERECHNUNG_PWM_w

	cpi temp1,53 ; C			
	ldi temp9,120; 	PWM (soll)	
	breq BERECHNUNG_PWM_w
	brlo BERECHNUNG_PWM_w

	cpi temp1,54 ; C			
	ldi temp9,140; 	PWM (soll)	
	breq BERECHNUNG_PWM_w
	brlo BERECHNUNG_PWM_w

	cpi temp1,55 ; C			
	ldi temp9,160; 	PWM (soll)	
	breq BERECHNUNG_PWM_w
	brlo BERECHNUNG_PWM_w

	cpi temp1,56 ; C			
	ldi temp9,180; 	PWM (soll)	
	breq BERECHNUNG_PWM_w
	brlo BERECHNUNG_PWM_w

	cpi temp1,57 ; C			
	ldi temp9,200; 	PWM (soll)	
	breq BERECHNUNG_PWM_w
	brlo BERECHNUNG_PWM_w

	cpi temp1,58 ; C			
	ldi temp9,220; 	PWM (soll)	
	breq BERECHNUNG_PWM_w
	brlo BERECHNUNG_PWM_w

	cpi temp1,59 ; C			
	ldi temp9,240; 	PWM (soll)	
	breq BERECHNUNG_PWM_w
	brlo BERECHNUNG_PWM_w
	ldi temp9,255				; PWM (soll)	
	STS(adr_PWM_IST),temp9		; save (ist) volle Pulle
;-------------------------------------------------------------------------------
BERECHNUNG_PWM_w:
	STS(adr_PWM_SOLL),temp9 	; save soll
	LDS temp8,(adr_PWM_IST)
	cp temp9,temp8
	breq BERECHNUNG_PWM_NIX
	brsh BERECHNUNG_PWM_PLUS
	brlo BERECHNUNG_PWM_MINUS
;-------------------------------------------------------------------------------
BERECHNUNG_PWM_PLUS:
	LDS temp,(adr_PWM_IST)
	inc temp
	STS(adr_PWM_IST),temp	; save
	ret
;-------------------------------------------------------------------------------
BERECHNUNG_PWM_NIX:
	ret
;-------------------------------------------------------------------------------
BERECHNUNG_PWM_MINUS:
	LDS temp,(adr_PWM_IST)
	dec temp
	STS(adr_PWM_IST),temp	; save
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
BERECHNUNG_mV_TEMP1_2:
	LDS temp1,(adr_ADC_mV_L)	; ADC		
	LDS temp2,(adr_ADC_mV_H)
	LDS ZL,(adr_FAKTOR_mV_L)	; Faktor	
	LDS ZH,(adr_FAKTOR_mV_H)
rjmp BERECHNUNG_Z_TEMP1_2
; ##############################################################################
; ##############################################################################
; ##############################################################################
BERECHNUNG_V_TEMP1_2:
	LDS temp1,(adr_ADC_V_L)		; ADC		
	LDS temp2,(adr_ADC_V_H)
	LDS ZL,(adr_FAKTOR_V_L)		; Faktor	
	LDS ZH,(adr_FAKTOR_V_H)
rjmp BERECHNUNG_Z_TEMP1_2
; ##############################################################################
; ##############################################################################
; ##############################################################################
BERECHNUNG_STROM_TEMP1_2:
	LDS temp1,(adr_ADC_i_L)	; ADC				
	LDS temp2,(adr_ADC_i_H)
	LDS R2,(adr_OFFSET_I_L)	; OFFSET			
	LDS R3,(adr_OFFSET_I_H)
	sub temp1,R2
	sbc temp2,R3
;-------------------------------------------------------------------------------
; Differenz negativ ?															
	tst temp2
	brpl BERECHNUNG_I_RUN
	clr temp1
	clr temp2
;-------------------------------------------------------------------------------
BERECHNUNG_I_RUN:
	LDS ZL,(adr_FAKTOR_I_L)	; Faktor			
	LDS ZH,(adr_FAKTOR_I_H)
 	rcall BERECHNUNG_Z_TEMP1_2
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
BERECHNUNG_TEMPERATUR_TEMP1_2:
	LDS temp1,(adr_ADC_T_L)
	LDS temp2,(adr_ADC_T_H)
;-------------------------------------------------------------------------------
; Offset																		
	ldi temp3,low  (679)
	ldi temp4,high (679)
	sub temp1,temp3
	sbc temp2,temp4
;-------------------------------------------------------------------------------
	ldi ZL,low (280)			; Faktor	
	ldi ZH,high(280)
	rcall BERECHNUNG_Z_TEMP1_2	; Berechnung
	STS(adr_TEMPERATUR),temp1	; SAVE		
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
BERECHNUNG_Z_TEMP1_2:
	mov temp3,ZL	
	mov temp4,ZH
	rcall MULTIPLIKATION_16_16_32	; mal Faktor	
	ldi ZL,LOW (1024/2)				; aufrunden		
	ldi ZH,HIGH(1024/2)
	add temp1,ZL
	adc temp2,ZH
	adc temp3,NULL
	mov temp1,temp2					; : 1024		
	mov temp2,temp3
	LSR temp2
	ROR temp1
	LSR temp2
	ROR temp1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
.include "MENUE.asm"
.include "EEPROM.asm"
.include "TIMER.asm"
.include "SONSTIGES.asm"
.include "ADC.asm"
.include "LED.asm"
.include "ZAHL.asm"
.include "WAIT.asm"
